//+------------------------------------------------------------------+
//|                                              AstroIndicator4.mq4 |
//|                                                        nowindows |
//|                                                  nowindows@nm.ru |
//+------------------------------------------------------------------+
#property copyright "nowindows"
#property link      "nowindows@nm.ru"

// last modified 03.04.2006
// last modified 15.03.2006
// ...
// last modified 26.10.2005
// last modified 27.05.2005
// created by 25.05.2005

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 RoyalBlue
#property indicator_color2 RoyalBlue

extern int    Body = 1;
extern int    Body2 = -1;
extern string NatalDate = "none";//"1971.01.04 00:00";

extern bool   isPointsShow = false;
extern int    PointsOfNumber = 4;

extern bool   islatitude = false;
extern bool   isdistance = false;
extern bool   isspeed = false;
extern bool   is360 = false;
extern int    iflag = 0;

extern int    FutureBars=100;
extern int    BarsLimit=1000;

extern int Period_ = 1;


int period_ = 0;
double past_longtitude = -1;


#include <astro_swiss.mq4>
#include <astro_func.mq4>
#include <time.mq4>

//---- buffers
double ExtMapBuffer1[];

double ExtMapBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,FutureBars);
   
   string short_name = "AstroIndicator4 " + astro_bodyname(Body);
   if(Body2 != -1)
   {
     short_name = short_name + " " + astro_bodyname(Body2);
   }
   if(Period_ > 1)
   {
     short_name = short_name + " " + DoubleToStr(Period_,0) + " periods";
   }
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexShift(1,FutureBars);
   SetIndexEmptyValue(1,0.0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   int limit;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   int shift = limit - FutureBars;
   if (shift < 0)
   {
     return(0);
   }
//---- TODO: add your code here
   
   
   // topo
   //spb astro_swe_set_topo(53,50,0);
   // new york
   // 40.5 N 74W
   astro_swe_set_topo(40.5,-74,0);
   
   
   
   // Draw Normal
   //
   if (shift > BarsLimit)
   {
     shift = BarsLimit;
   }
   while ( shift > 0 )
   {
     double value = get_astro_value(Time[shift]);
     ExtMapBuffer1[shift + FutureBars] = value;
     
     if(isPointsShow == true)
     {
       double step_point = 360/PointsOfNumber;
       double step_number = MathRound(value/step_point)*step_point;
       if(MathAbs(value - step_number) < 3)
       {
         ExtMapBuffer2[shift + FutureBars] = step_number;
       }
     }
     
     shift = shift - 1;
   }
   
   
   
   // Draw Future
   // now shift = 0
   datetime curr_datetime = Time[shift];
   int period_ = get_period(shift);
   
   while ( shift > -FutureBars )
   {
     ExtMapBuffer1[shift + FutureBars] = get_astro_value(curr_datetime);
     shift = shift - 1;
     curr_datetime = curr_datetime + period_;
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


double get_astro_value(datetime d)
{
   //int Body = SE_MOON;
   double longtitude, latitude;
   double longtitude2, latitude2;
   double distance, distance2;
   double speed;
   
   if(NatalDate != "none")
   {
     if(Body2 == -1)
     {
       astro_swe_calc(StrToTime(NatalDate), Body, iflag, longtitude, latitude, distance, speed);
       astro_swe_calc(d, Body, iflag, longtitude2, latitude2, distance2, speed);
       if(is360)
       {
         return(func_P360(longtitude,longtitude2));
       }
       else
       {
         return(func_P(longtitude,longtitude2));
       }
     }
     else
     {
       astro_swe_calc(StrToTime(NatalDate), Body, iflag, longtitude, latitude, distance, speed);
       astro_swe_calc(StrToTime(NatalDate), Body2, iflag, longtitude2, latitude2, distance2, speed);
       double natal_angle = func_P360(longtitude, longtitude2);
       astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
       astro_swe_calc(d, Body2, iflag, longtitude2, latitude2, distance2, speed);
       double now_angle = func_P360(longtitude, longtitude2);
       return(func_P(natal_angle,now_angle));
     }
   }
   
   if(isdistance)
   {
     astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
     return(distance);
   }
   if(isspeed)
   {
     astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
     return(speed);
   }
   
   if (Body2 != -1)
   {
     astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
     astro_swe_calc(d, Body2, iflag, longtitude2, latitude2, distance2, speed);
     if (is360)
     {
       return(func_P360(longtitude,longtitude2));
     }
     else
     {
       return(func_P(longtitude,longtitude2));
     }
   }
   else
   {
     astro_swe_calc(d, Body, iflag, longtitude, latitude, distance, speed);
     if (islatitude == true)
     {
       return(latitude);
     }
     else
     {
       if(Period_ > 1)
       {
         if(past_longtitude - longtitude > 100) // -1 -some < 0
         {
           period_ = period_ + 1;
           if(period_ >= Period_)
           {
             period_ = 0;
           }
         }
         past_longtitude = longtitude;
         return(360*period_+longtitude);
       }
       else
       {
         return(longtitude);
       }
     }
   }
}

