//+------------------------------------------------------------------+
//|                                    AstroIndicator_Retrograde.mq4 |
//|                                                        nowindows |
//|                                                  nowindows@nm.ru |
//+------------------------------------------------------------------+
#property copyright "nowindows"
#property link      "nowindows@nm.ru"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 3
#property indicator_buffers 1
#property indicator_color1 RoyalBlue
//---- input parameters
extern int       Body=2;
extern int       FutureBars=100;
extern int       BarsLimit=1000;


//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexShift(0,FutureBars);
   
   string short_name = "AstroIndicator_Retrograde " + astro_bodyname(Body);
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   int limit;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   int shift = limit - FutureBars;
   if (shift < 0)
   {
     return(0);
   }
//---- TODO: add your code here
   
   int period_ = get_period(shift);
   
   // Draw Normal
   //
   if (shift > BarsLimit)
   {
     shift = BarsLimit;
   }
   while ( shift > 0 )
   {
     int ret;
     if(is_retrograde(Time[shift], period_, Body,0) == true)
     {
       ret = 1;
     }
     else
     {
       ret = 0;
     }
     ExtMapBuffer1[shift + FutureBars] = ret;
     shift = shift - 1;
   }
   
   // Draw Future
   // now shift = 0
   datetime curr_datetime = Time[shift];
   while ( shift > -FutureBars )
   {
     if(is_retrograde(curr_datetime, period_, Body,0) == true)
     {
       ret = 1;
     }
     else
     {
       ret = 0;
     }
     ExtMapBuffer1[shift + FutureBars] = ret;
     shift = shift - 1;
     curr_datetime = curr_datetime + period_;
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


#include <time.mq4>
#include <astro_func.mq4>





